WinStd Additional templates and function helpers for Microsoft Windows using Standard C++ classes

Public Member Functions | Protected Member Functions | List of all members
winstd::setup_device_info_list Class Reference
Setup API

HDEVINFO wrapper class. More...

`#include <SetupAPI.h>`

Inheritance diagram for winstd::setup_device_info_list:

## Public Member Functions
virtual | ~setup_device_info_list ()
| Frees the device information set. More...
bool | create (_In_opt_ const GUID *ClassGuid, _In_opt_ HWND hwndParent) noexcept
| Creates an empty device information set and optionally associates the set with a device setup class and a top-level window. More...
bool | create (_In_opt_ const GUID *ClassGuid, _In_opt_ PCTSTR Enumerator, _In_opt_ HWND hwndParent, _In_ DWORD Flags, _In_opt_ HDEVINFO DeviceInfoSet, _In_opt_ PCTSTR MachineName, _Reserved_ PVOID Reserved) noexcept
| Creates a device information set that contains requested device information elements for a local or a remote computer. More...
Public Member Functions inherited from winstd::handle< HDEVINFO, INVALID_HANDLE_VALUE >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (_In_opt_ handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (_In_opt_ handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (_In_opt_ handle_type h) const
| Is handle less than? More...
bool | operator<= (_In_opt_ handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (_In_opt_ handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (_In_opt_ handle_type h) const
| Is handle greater than? More...
bool | operator!= (_In_opt_ handle_type h) const
| Is handle not equal to? More...
bool | operator== (_In_opt_ handle_type h) const
| Is handle equal to? More...
void | attach (_In_opt_ handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Protected Member Functions
void | free_internal () noexcept override
| Frees the device information set. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...

## Additional Inherited Members
Public Types inherited from winstd::handle< HDEVINFO, INVALID_HANDLE_VALUE >
typedef HDEVINFO | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< HDEVINFO, INVALID_HANDLE_VALUE >
static const HDEVINFO | invalid
| Invalid handle value.
Protected Attributes inherited from winstd::handle< HDEVINFO, INVALID_HANDLE_VALUE >
handle_type | m_h
| Object handle.

## Detailed Description

HDEVINFO wrapper class.

## Constructor & Destructor Documentation

## ◆ ~setup_device_info_list()

virtual winstd::setup_device_info_list::~setup_device_info_list | ( |  | ) |
| inline virtual

Frees the device information set.

See also
  SetupDiDestroyDeviceInfoList function

## Member Function Documentation

## ◆ create() [1/2]

bool winstd::setup_device_info_list::create | ( | _In_opt_ const GUID * | ClassGuid,
|  | _In_opt_ HWND | hwndParent
| ) |  |
| inline noexcept

Creates an empty device information set and optionally associates the set with a device setup class and a top-level window.

Returns
  - true when creation succeeds;
  - false when creation fails. For extended error information, call `GetLastError()`.

See also
  SetupDiCreateDeviceInfoList function

## ◆ create() [2/2]

bool winstd::setup_device_info_list::create | ( | _In_opt_ const GUID * | ClassGuid,
|  | _In_opt_ PCTSTR | Enumerator,
|  | _In_opt_ HWND | hwndParent,
|  | _In_ DWORD | Flags,
|  | _In_opt_ HDEVINFO | DeviceInfoSet,
|  | _In_opt_ PCTSTR | MachineName,
|  | _Reserved_ PVOID | Reserved
| ) |  |
| inline noexcept

Creates a device information set that contains requested device information elements for a local or a remote computer.

Returns
  - true when creation succeeds;
  - false when creation fails. For extended error information, call `GetLastError()`.

See also
  SetupDiGetClassDevsExW function

## ◆ free_internal()

void winstd::setup_device_info_list::free_internal | ( |  | ) |
| inline override protected virtual noexcept

Frees the device information set.

See also
  SetupDiDestroyDeviceInfoList function

Implements winstd::handle< HDEVINFO, INVALID_HANDLE_VALUE >.

The documentation for this class was generated from the following file:

- include/WinStd/SetupAPI.h